from Products.validation import validation
from Products.validation.interfaces.IValidator import IValidator
from Products.CMFCore.utils import getToolByName

class CaptchaValidator:
    """
    Captcha validator. To be used with CaptchaWidget.
    """

    __implements__ = IValidator

    def __init__(self, name, title='', description=''):
        self.name = name
        self.title = title
        self.description = description


    def __call__(self, value, *args, **kwargs):
        """
        Tests if the Captcha value matches the image.
        """
        
        # XXX: For some reason, this validator is called twice.
        # If there's no request, we're not coming from the form
        # so...ignore?
        
        if kwargs['REQUEST'] != None:
        
            hidden_captcha_code = kwargs['REQUEST']['hidden_captcha_code']
            pct =  getToolByName(kwargs['instance'],'portal_captcha')
            generated_code = pct.getGeneratedCaptchaCode(hidden_captcha_code)
            
            if generated_code != value:
                return 'Verification Code does not match.'

        return 1

captcha_validator = CaptchaValidator('CaptchaMatch', 
    'Captcha input matches image')

validation.register(captcha_validator)
